%global dlrn_nvr mistral-9.1.1.dev4-2.20230627005009.c66cf75
%global dlrn 1
%define upstream_version 9.1.1.dev4
# Macros for py2/py3 compatibility
%if 0%{?fedora} || 0%{?rhel} > 7
%global pyver %{python3_pkgversion}
%else
%global pyver 2
%endif

%global pyver_bin python%{pyver}
%global pyver_sitelib %{expand:%{python%{pyver}_sitelib}}
%global pyver_install %{expand:%{py%{pyver}_install}}
%global pyver_build %{expand:%{py%{pyver}_build}}
# End of macros for py2/py3 compatibility

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global service mistral
%global rhosp 1

%global with_doc 0

%global common_desc \
Mistral is a workflow service. \
Most business processes consist of multiple distinct interconnected steps that \
need to be executed in a particular order in a distributed environment. One can \
describe such process as a set of tasks and task relations and upload such \
description to Mistral so that it takes care of state management, correct \
execution order, parallelism, synchronization and high availability.

Name:           openstack-mistral
Version: 9.1.1
Release: 2.20230627005009.c66cf75%{?dist}
Summary:        Task Orchestration and Scheduling service for OpenStack cloud
License:        ASL 2.0
URL:            https://launchpad.net/mistral
Source0: mistral-9.1.1.dev4-2.20230627005009.c66cf75.tar.gz
#
# patches_ignore=DROP-IN-RPM
# patches_base=c66cf75a50bf2772b0b23f89f1a911d3d5f72875

#

Source1:        mistral.logrotate
# Systemd scripts
Source10:       openstack-mistral-api.service
Source11:       openstack-mistral-engine.service
Source12:       openstack-mistral-executor.service
Source13:       openstack-mistral-all.service
Source14:       openstack-mistral-event-engine.service
Source15:       openstack-mistral-notifier.service

BuildArch:      noarch

BuildRequires:  git
BuildRequires:  openstack-macros
BuildRequires:  python%{pyver}-devel
BuildRequires:  python%{pyver}-oslo-config >= 2:5.2.0
BuildRequires:  python%{pyver}-pbr >= 2.0.0
BuildRequires:  systemd

%if %{pyver} == 3
BuildRequires:  /usr/bin/pathfix.py
%endif

%description
%{summary}


%package -n     python%{pyver}-%{service}
Summary:        Mistral Python libraries
%{?python_provide:%python_provide python%{pyver}-%{service}}

Requires:       python%{pyver}-alembic >= 0.9.6
Requires:       python%{pyver}-babel >= 2.3.4
Requires:       python%{pyver}-croniter >= 0.3.4
Requires:       python%{pyver}-cachetools >= 2.0.0
Requires:       python%{pyver}-eventlet >= 0.20.0
Requires:       python%{pyver}-iso8601 >= 0.1.9
Requires:       python%{pyver}-jinja2
Requires:       python%{pyver}-jsonschema >= 2.6.0
Requires:       python%{pyver}-kombu
Requires:       python%{pyver}-oauthlib
Requires:       python%{pyver}-paramiko >= 2.0.0
Requires:       python%{pyver}-pbr >= 2.0.0
Requires:       python%{pyver}-pecan >= 1.2.1
Requires:       python%{pyver}-requests >= 2.14.2
Requires:       python%{pyver}-six >= 1.10.0
Requires:       python%{pyver}-sqlalchemy >= 1.2.5
Requires:       python%{pyver}-tenacity >= 5.0.1
Requires:       python%{pyver}-wsme >= 0.8.0
Requires:       python%{pyver}-yaql >= 1.1.3
Requires:       python%{pyver}-dogpile-cache
# OpenStack dependencies
Requires:       python%{pyver}-oslo-concurrency >= 3.26.0
Requires:       python%{pyver}-oslo-config >= 2:5.2.0
Requires:       python%{pyver}-oslo-context >= 2.20.0
Requires:       python%{pyver}-oslo-db >= 4.27.0
Requires:       python%{pyver}-oslo-i18n >= 3.15.3
Requires:       python%{pyver}-oslo-middleware >= 3.31.0
Requires:       python%{pyver}-oslo-messaging >= 5.29.0
Requires:       python%{pyver}-oslo-utils >= 3.37.0
Requires:       python%{pyver}-oslo-log >= 3.36.0
Requires:       python%{pyver}-oslo-serialization >= 2.18.0
Requires:       python%{pyver}-oslo-service >= 1.24.0
Requires:       python%{pyver}-oslo-policy >= 1.30.0
Requires:       python%{pyver}-osprofiler >= 1.4.0
Requires:       python%{pyver}-stevedore >= 1.20.0
Requires:       python%{pyver}-tooz >= 1.58.0
Requires:       python%{pyver}-aodhclient >= 0.9.0
Requires:       python%{pyver}-barbicanclient >= 4.5.2
Requires:       python%{pyver}-cinderclient >= 3.3.0
Requires:       python%{pyver}-glanceclient >= 1:2.8.0
Requires:       python%{pyver}-gnocchiclient >= 3.3.1
Requires:       python%{pyver}-ironicclient >= 2.7.0
Requires:       python%{pyver}-ironic-inspector-client >= 1.5.0
Requires:       python%{pyver}-heatclient >= 1.10.0
Requires:       python%{pyver}-keystoneclient >= 1:3.8.0
Requires:       python%{pyver}-keystonemiddleware >= 4.18.0
Requires:       python%{pyver}-neutronclient >= 6.7.0
Requires:       python%{pyver}-novaclient >= 1:9.1.0
Requires:       python%{pyver}-swiftclient >= 3.2.0
Requires:       python%{pyver}-zaqarclient >= 1.0.0
Requires:       python%{pyver}-mistralclient >= 3.1.0
Requires:       python%{pyver}-mistral-lib >= 1.2.0
Requires:       python%{pyver}-designateclient >= 2.7.0
Requires:       python%{pyver}-magnumclient >= 2.1.0
Requires:       python%{pyver}-manilaclient >= 1.23.0
%if 0%{rhosp} == 0
Requires:       python%{pyver}-glareclient >= 0.3.0
Requires:       python%{pyver}-muranoclient >= 0.8.2
Requires:       python%{pyver}-senlinclient >= 1.1.0
Requires:       python%{pyver}-tackerclient >= 0.8.0
Requires:       python%{pyver}-vitrageclient >= 2.0.0
%endif
Requires:       python%{pyver}-troveclient >= 2.2.0

# Handle python2 exceptions
%if %{pyver} == 2
Requires:       python-jwt >= 1.0.1
Requires:       python-retrying >= 1.2.3
Requires:       python-networkx >= 1.10
Requires:       PyYAML >= 3.10
%else
Requires:       python%{pyver}-jwt >= 1.0.1
Requires:       python%{pyver}-retrying >= 1.2.3
Requires:       python%{pyver}-networkx >= 1.10
Requires:       python%{pyver}-PyYAML >= 3.10
%endif

%description -n python%{pyver}-%{service}
%{common_desc}

This package contains the Python libraries.

%package        common
Summary: Components common for OpenStack Mistral

Requires:       python%{pyver}-%{service} = %{version}-%{release}
%if 0%{?rhel} && 0%{?rhel} < 8
%{?systemd_requires}
%else
%{?systemd_ordering} # does not exist on EL7
%endif

%description    common
%{common_desc}

This package contains the common files.

%package        api
Summary: OpenStack Mistral API daemon

Requires:       %{name}-common = %{version}-%{release}

%description    api
OpenStack rest API to the Mistral Engine.
.
This package contains the ReST API.

%package        engine
Summary: OpenStack Mistral Engine daemon

Requires:       %{name}-common = %{version}-%{release}

%description    engine
OpenStack Mistral Engine service.
.
This package contains the mistral engine, which is one of core services of
mistral.

%package        executor
Summary: OpenStack Mistral Executor daemon

Requires:       %{name}-common = %{version}-%{release}

%description    executor
OpenStack Mistral Executor service.
.
This package contains the mistral executor, which is one of core services of
mistral, and which the API servers will use.

%package        event-engine
Summary: Openstack Mistral Event Engine daemon

Requires:       %{name}-common = %{version}-%{release}

%description    event-engine
Openstack Mistral Event Engine service.
.
This package contains the mistral event engine, which is one of the core
services of mistral.

%package        notifier
Summary: Openstack Mistral Notifier daemon

Requires:       %{name}-common = %{version}-%{release}

%description    notifier
Openstack Mistral Notifier service.
.
This package contains the mistral notifier, which is one of the core
services of mistral.

%package        all
Summary: OpenStack Mistral All-in-one daemon

Requires:       %{name}-common = %{version}-%{release}

%description    all
OpenStack Mistral All service.
.
This package contains the mistral api, engine, and executor service as
an all-in-one process.

%package -n python%{pyver}-mistral-tests
Summary:        Mistral tests
%{?python_provide:%python_provide python%{pyver}-mistral-tests}
Requires:       %{name}-common = %{version}-%{release}
Requires:       python%{pyver}-mock

%description -n python%{pyver}-mistral-tests
This package contains the mistral test files.


%if 0%{?with_doc}
%package        doc
Summary:        Documentation for OpenStack Workflow Service

BuildRequires:  python%{pyver}-sphinx
BuildRequires:  python%{pyver}-openstackdocstheme
BuildRequires:  python%{pyver}-sphinxcontrib-pecanwsme
BuildRequires:  python%{pyver}-wsme
BuildRequires:  python%{pyver}-croniter
BuildRequires:  python%{pyver}-eventlet
BuildRequires:  python%{pyver}-jsonschema
BuildRequires:  python%{pyver}-keystoneclient
BuildRequires:  python%{pyver}-keystonemiddleware
BuildRequires:  python%{pyver}-mistral-lib
BuildRequires:  python%{pyver}-oslo-db
BuildRequires:  python%{pyver}-oslo-log
BuildRequires:  python%{pyver}-oslo-messaging
BuildRequires:  python%{pyver}-oslo-policy
BuildRequires:  python%{pyver}-osprofiler
BuildRequires:  python%{pyver}-pecan
BuildRequires:  python%{pyver}-tooz
BuildRequires:  python%{pyver}-yaql
BuildRequires:  python%{pyver}-oauthlib
BuildRequires:  openstack-macros

# Handle python2 exceptions
%if %{pyver} == 2
BuildRequires:  python-sphinxcontrib-httpdomain
BuildRequires:  python-networkx
%else
BuildRequires:  python%{pyver}-sphinxcontrib-httpdomain
BuildRequires:  python%{pyver}-networkx
%endif


%description    doc
OpenStack Mistral documentation.
.
This package contains the documentation.
%endif

%prep
%autosetup -n mistral-%{upstream_version} -S git

sed -i '1i #!/usr/bin/python' tools/sync_db.py

%py_req_cleanup

%build
%{pyver_build}
oslo-config-generator-%{pyver} --config-file tools/config/config-generator.mistral.conf \
                      --output-file etc/mistral.conf.sample

%install
%{pyver_install}


%if 0%{?with_doc}
# FIXME(jcapitao) Remove -W until we move to centos8
export PYTHONPATH=.
sphinx-build-%{pyver} -b html doc/source doc/build/html
rm -rf doc/build/html/.{doctrees,buildinfo}
%endif

mkdir -p %{buildroot}/etc/mistral/
mkdir -p %{buildroot}/var/log/mistral
mkdir -p %{buildroot}/var/run/mistral
mkdir -p %{buildroot}/var/lib/mistral

install -p -D -m 644 %SOURCE10 %{buildroot}%{_unitdir}/openstack-mistral-api.service
install -p -D -m 644 %SOURCE11 %{buildroot}%{_unitdir}/openstack-mistral-engine.service
install -p -D -m 644 %SOURCE12 %{buildroot}%{_unitdir}/openstack-mistral-executor.service
install -p -D -m 644 %SOURCE13 %{buildroot}%{_unitdir}/openstack-mistral-all.service
install -p -D -m 644 %SOURCE14 %{buildroot}%{_unitdir}/openstack-mistral-event-engine.service
install -p -D -m 644 %SOURCE15 %{buildroot}%{_unitdir}/openstack-mistral-notifier.service

install -p -D -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-mistral
install -p -D -m 640 etc/mistral.conf.sample \
                     %{buildroot}%{_sysconfdir}/mistral/mistral.conf
install -p -D -m 640 etc/logging.conf.sample \
                     %{buildroot}%{_sysconfdir}/mistral/logging.conf
install -p -D -m 640 etc/wf_trace_logging.conf.sample \
                     %{buildroot}%{_sysconfdir}/mistral/wf_trace_logging.conf
install -p -D -m 640 etc/policy.json \
                     %{buildroot}%{_sysconfdir}/mistral/policy.json
install -p -D -m 640 tools/sync_db.py \
                     %{buildroot}/usr/bin/mistral-db-sync
chmod +x %{buildroot}/usr/bin/mistral*

%if %{pyver} == 3
# Fix shebangs for Python 3-only distros
pathfix.py -pni "%{__python3} %{py3_shbang_opts}" %{buildroot}/usr/bin/mistral-db-sync
%endif

install -p -D -m 644 ./mistral/actions/openstack/mapping.json %{buildroot}%{pyver_sitelib}/%{service}/actions/openstack/mapping.json
install -p -D -m 644 ./mistral/db/sqlalchemy/migration/alembic.ini %{buildroot}%{pyver_sitelib}/%{service}/db/sqlalchemy/migration/alembic.ini
mkdir -p %{buildroot}/%{pyver_sitelib}/%{service}/resources/workflows/
mkdir -p %{buildroot}/%{pyver_sitelib}/%{service}/resources/actions/
install -p -D -m 644 ./mistral/resources/workflows/* %{buildroot}/%{pyver_sitelib}/%{service}/resources/workflows/
install -p -D -m 644 ./mistral/resources/actions/* %{buildroot}/%{pyver_sitelib}/%{service}/resources/actions/

%pre common
USERNAME=mistral
GROUPNAME=$USERNAME
HOMEDIR=/var/lib/mistral
getent group $GROUPNAME >/dev/null || groupadd -r $GROUPNAME
getent passwd $USERNAME >/dev/null ||
    useradd -r -g $GROUPNAME -G $GROUPNAME -d $HOMEDIR -s /sbin/nologin \
            -c "Mistral Daemons" $USERNAME
# Related Bug LP#1778269
if [ "$(getent passwd $USERNAME | cut -d: -f6)" != "$HOMEDIR" ]; then
    usermod -m -d $HOMEDIR $USERNAME
fi
exit 0


%post api
%systemd_post openstack-mistral-api.service
%preun api
%systemd_preun openstack-mistral-api.service
%postun api
%systemd_postun_with_restart openstack-mistral-api.service

%post engine
%systemd_post openstack-mistral-engine.service
%preun engine
%systemd_preun openstack-mistral-engine.service
%postun engine
%systemd_postun_with_restart openstack-mistral-engine.service

%post executor
%systemd_post openstack-mistral-executor.service
%preun executor
%systemd_preun openstack-mistral-executor.service
%postun executor
%systemd_postun_with_restart openstack-mistral-executor.service

%post event-engine
%systemd_post openstack-mistral-event-engine.service
%preun event-engine
%systemd_preun openstack-mistral-event-engine.service
%postun event-engine
%systemd_postun_with_restart openstack-mistral-event-engine.service

%post notifier
%systemd_post openstack-mistral-notifier.service
%preun notifier
%systemd_preun openstack-mistral-notifier.service
%postun notifier
%systemd_postun_with_restart openstack-mistral-notifier.service

%post all
%systemd_post openstack-mistral-all.service
%preun all
%systemd_preun openstack-mistral-all.service
%postun all
%systemd_postun_with_restart openstack-mistral-all.service

%files api
%config(noreplace) %attr(-, root, root) %{_unitdir}/openstack-mistral-api.service

%files common
%dir %{_sysconfdir}/mistral
%config(noreplace) %attr(-, mistral, mistral) %{_sysconfdir}/mistral/*
%config(noreplace) %{_sysconfdir}/logrotate.d/openstack-mistral
%{_bindir}/mistral-*
%dir %attr(755, mistral, mistral) /var/run/mistral
%dir %attr(750, mistral, mistral) /var/lib/mistral
%dir %attr(750, mistral, mistral) /var/log/mistral


%if 0%{?with_doc}
%files doc
%doc doc/build/html
%endif

%files engine
%config(noreplace) %attr(-, root, root) %{_unitdir}/openstack-mistral-engine.service

%files executor
%config(noreplace) %attr(-, root, root) %{_unitdir}/openstack-mistral-executor.service

%files event-engine
%config(noreplace) %attr(-, root, root) %{_unitdir}/openstack-mistral-event-engine.service

%files notifier
%config(noreplace) %attr(-, root, root) %{_unitdir}/openstack-mistral-notifier.service

%files all
%config(noreplace) %attr(-, root, root) %{_unitdir}/openstack-mistral-all.service


%files -n python%{pyver}-%{service}
%{pyver_sitelib}/%{service}
%{pyver_sitelib}/%{service}-*.egg-info
%exclude %{pyver_sitelib}/mistral/tests

%files -n python%{pyver}-mistral-tests
%license LICENSE
%{pyver_sitelib}/mistral/tests

%changelog
* Mon Jun 26 2023 OSP Prod Chain <dev-null@redhat.com> 9.1.1-2.20230627005009.c66cf75
- Update patches
- Update zuul queue configuration

* Thu Jul 29 2021 OSP Prod Chain <dev-null@redhat.com> 9.1.1-2.20210729225824.62b0b37
- Update patches

* Thu May 27 2021 OSP Prod Chain <dev-null@redhat.com> 9.1.1-2.20210527192117.62b0b37
- Update patches

* Thu Dec 17 2020 OSP Prod Chain <dev-null@redhat.com> 9.1.0-1
- Update patches

* Fri Oct 30 2020 OSP Prod Chain <dev-null@redhat.com> 9.1.0-1
- Update patches

* Tue Jul 21 2020 OSP Prod Chain <dev-null@redhat.com> 9.1.0-1
- Update patches

* Thu Jul 16 2020 OSP Prod Chain <dev-null@redhat.com> 9.1.0-1
- Update patches

* Tue Jun 23 2020 OSP Prod Chain <dev-null@redhat.com> 9.1.0-1
- Update patches
- Update requirements to include oauthlib

* Wed Jun 17 2020 OSP Prod Chain <dev-null@redhat.com> 9.1.0-1
- Update patches
- Disable the use of anchors when parsing yaml

* Thu Apr 23 2020 OSP Prod Chain <dev-null@redhat.com> 9.1.0-1
- Update patches

* Mon Apr 13 2020 OSP Prod Chain <dev-null@redhat.com> 9.0.1-1
- Update patches
- Add YAQL sanitizing for iterators

* Wed Apr 08 2020 OSP Prod Chain <dev-null@redhat.com> 9.0.1-1
- Update patches
- Use py3 in rally new version supports only py3

* Wed Apr 08 2020 OSP Prod Chain <dev-null@redhat.com> 9.0.1-1
- Update patches
- Use constraints for docs installs

* Fri Apr 03 2020 OSP Prod Chain <dev-null@redhat.com> 9.0.1-1
- Update patches
- Fix serialization of structures that might contain YAQL types

* Thu Mar 19 2020 OSP Prod Chain <dev-null@redhat.com> 9.0.1-1
- Update patches
- Fix ContextView JSON serialization

* Wed Mar 11 2020 OSP Prod Chain <dev-null@redhat.com> 9.0.1-1
- Update patches
- Fix incorrect in-depth search of affected tasks

* Tue Mar 10 2020 OSP Prod Chain <dev-null@redhat.com> 9.0.1-1
- Update patches

* Fri Feb 28 2020 OSP Prod Chain <dev-null@redhat.com> 9.0.1-1
- Update patches

* Wed Feb 26 2020 OSP Prod Chain <dev-null@redhat.com> 9.0.1-1
- Update patches
- Fix YAQL engine initialization

* Fri Feb 21 2020 OSP Prod Chain <dev-null@redhat.com> 9.0.1-1
- Update patches
- Release note for "convert_output_data" config option
- Add "convert_output_data" config property for YAQL
- Move registration of CLI options to launch.py

* Mon Feb 10 2020 OSP Prod Chain <dev-null@redhat.com> 9.0.1-1
- Update patches
- Set the delayed call "key" field to the right value

* Mon Nov 25 2019 OSP Prod Chain <dev-null@redhat.com> 9.0.1-1
- Update patches

* Fri Nov 22 2019 OSP Prod Chain <dev-null@redhat.com> 9.0.0-1
- Update patches
- Merge "Make sure minimum amqp is 2.5.2" into stable/train
- Make sure minimum amqp is 2.5.2

* Mon Nov 18 2019 OSP Prod Chain <dev-null@redhat.com> 9.0.0-1
- Update patches
- Merge "Make action heartbeats work for all executor types" into stable/train
- Make action heartbeats work for all executor types

* Mon Nov 18 2019 OSP Prod Chain <dev-null@redhat.com> 9.0.0-1
- Update patches
- Merge "Mask sensitive data when logging action results" into stable/train
- Mask sensitive data when logging action results

* Mon Nov 18 2019 OSP Prod Chain <dev-null@redhat.com> 9.0.0-1
- Update patches
- Refactor action execution reporter

* Wed Oct 30 2019 OSP Prod Chain <dev-null@redhat.com> 9.0.0-1
- Update patches
- Evaluate input expression should check the in_context

* Thu Oct 24 2019 OSP Prod Chain <dev-null@redhat.com> 9.0.0-1
- Update patches
- Using std.ssh without private_key_filename causes TypeError

* Thu Oct 17 2019 OSP Prod Chain <dev-null@redhat.com> 9.0.0-1
- Update patches

* Tue Oct 15 2019 OSP Prod Chain <dev-null@redhat.com> 9.0.0-0.2.0rc2
- Update patches
- Change the action error message format

* Mon Oct 14 2019 OSP Prod Chain <dev-null@redhat.com> 9.0.0-0.2.0rc2
- Update patches
- Fix the global publish for task

* Thu Oct 10 2019 OSP Prod Chain <dev-null@redhat.com> 9.0.0-0.1.0rc1
- Update patches
- Update TOX/UPPER_CONSTRAINTS_FILE for stable/train
- Merge "Update .gitreview for stable/train" into stable/train
- Update .gitreview for stable/train

* Wed Oct 09 2019 OSP Prod Chain <dev-null@redhat.com> 9.0.0-0.1.0rc1
- Update patches
- Fix "root_execution" lazy loading issue and refactor execution.py

* Fri Oct 04 2019 OSP Prod Chain <dev-null@redhat.com> 9.0.0-0.1.0rc1
- Update patches
- Add the explicit dependency from kombu

* Mon Sep 30 2019 RDO <dev@lists.rdoproject.org> 9.0.0-0.1.0rc1
- Update to 9.0.0.0rc1


